/*************************************************************

2021-08-20 
	-  WDT - ,  
	-       (  )
	-     
https://community.blynk.cc/t/c-blynk-legacy-code-examples-for-basic-tasks/22596/20
	- 
	- 



     (, ,   )
      

         ,    , 
      

!      -   ,  .... ---->   .....

       .
  ESP32
   WiFi 

-   ESP,  LED ( )  - V2
-    DS18b20 - V5
-    - ???
-    - V6
-    DS18b20
-       DHT
-    (, )   
-   ( ),  ,   
- 

-     () - V1



 *************************************************************/

//#include "MyClass.h"

#define BLYNK_PRINT Serial
#include <Arduino.h>
#include <esp_task_wdt.h>
#include <WiFi.h>
#include <WiFiClient.h>
#include <BlynkSimpleEsp32.h>
#include <OneWire.h>
//#include <ESPmDNS.h>
//#include <WiFiUdp.h>
//#include <ArduinoOTA.h>

float get_data_ds18b20(void);

// 2
const int DSD18B20PIN			= 14;      //    DATA
const int BlynkPinTerminal		= V71;
const int BlynkPinMonotorWork	= V72;
const int BlynkPinTemp1			= V75;
const int BlynkPinTime			= V76;
char ssid[] = "Bujarovo-Pool";
char pass[] = "9037269865";
char auth[] = "qctGvdWpJpvD37uoTA_ZQ7VviMpGSdJx";	//   


/*/ 1
const int DSD18B20PIN			= 25;      //    DATA
const int BlynkPinTerminal		= V71;
const int BlynkPinMonotorWork	= V72;
const int BlynkPinTemp1			= V75;
const int BlynkPinTime			= V76;
char ssid[] = "GL-AR750S-266-Guest";
char pass[] = "9037269865";
char auth[] = "qctGvdWpJpvD37uoTA_ZQ7VviMpGSdJx";	//    
*/

/*     (   )
const int DSD18B20PIN			= 15;		//    DATA 
const int BlynkPinTerminal		= V21;		// 
const int BlynkPinMonotorWork	= V22;
const int BlynkPinTemp1			= V25;
const int BlynkPinTime			= V26;
char ssid[]						= "Bujarovo";
char pass[]						= "9037269865";
char auth[]						= "H-UgPEqoa22yFoiqdvzDra_4TZu0Ga1u";	//  bvsad    
*/

/*   
const int DSD18B20PIN			= 15;		//    DATA 
const int BlynkPinTerminal		= V21;		// 
const int BlynkPinMonotorWork	= V12;
const int BlynkPinTemp1			= V15;
const int BlynkPinTime			= V16;
char ssid[]						= "Bujarovo-B";
char pass[]						= "9037269865";
char auth[]						= "H-UgPEqoa22yFoiqdvzDra_4TZu0Ga1u";	//  bvsad    
*/

/*    (   ) 
const int DSD18B20PIN			= 15;		//    DATA 
const int BlynkPinTerminal		= V21;		// 
const int BlynkPinMonotorWork	= V2;
const int BlynkPinTemp1			= V5;
const int BlynkPinTime			= V6;
char ssid[]						= "Bujarovo-B";
char pass[]						= "9037269865";
char auth[]						= "H-UgPEqoa22yFoiqdvzDra_4TZu0Ga1u";	//  bvsad    
*/

const uint32_t WDT_TIMEOUT =  3;				//   WDT
const unsigned long INTERVAL_GET_DATA = 2000;	//  , 

int ReCnctFlag;  // Reconnection Flag
int ReCnctCount = 0;  // Reconnection counter

char tmps[ 128 ];	//   ,   ,     
unsigned long millis_int1 = 0;		//    
float temp;
int c1 = 0;							//    ,   

OneWire ds( DSD18B20PIN ); 
WidgetTerminal terminal( BlynkPinTerminal );
BlynkTimer timer;


void myTimerEvent()
{
  if( ReCnctFlag != 0 ) esp_task_wdt_reset();
  
  
  Blynk.virtualWrite( BlynkPinTime, millis() / 1000 / 60 );
  
    Serial.print("UpTime: ");
    Serial.println(millis() / 1000);  // Send UpTime seconds to Serial

  if( temp < 125 ) Blynk.virtualWrite( BlynkPinTemp1, temp );
  
  if( (++c1) % 2 ) Blynk.virtualWrite( BlynkPinMonotorWork, 255 );
  else Blynk.virtualWrite( BlynkPinMonotorWork, 0 );
  
      if( temp < 100 )
      { 
	      sprintf( tmps, "temp=%.2f\n", temp );
	      stp( tmps );
      }  // end if(temp<100) 
  
  terminal.flush();
  
}  // end myTimerEvent()



BLYNK_CONNECTED() 
{
	Serial.println( "Cconnected" );
	ReCnctCount = 0;
}

void setup()
{
  Serial.begin( 115200 );

  //Blynk.begin( auth, ssid, pass, "bslchat.com", 8080 );
  //Blynk.begin( auth, ssid, pass, IPAddress(62,171,156,54), 8080 );
  
  WiFi.begin(ssid, pass);  // Non-blocking if no WiFi available
  Blynk.config(auth, IPAddress(62,171,156,54), 8080);
  Blynk.connect();

/*
  Serial.println( "Booting" );
  WiFi.mode( WIFI_STA );
  WiFi.begin( ssid, pass );
  
      while( WiFi.waitForConnectResult() != WL_CONNECTED ) 
      {
        Serial.println( "Connection Failed! Rebooting..." );
        delay( 5000 );
        ESP.restart( );
      }

  ArduinoOTA
    .onStart([]() {
      String type;
      if (ArduinoOTA.getCommand() == U_FLASH)
        type = "sketch";
      else // U_SPIFFS
        type = "filesystem";

      // NOTE: if updating SPIFFS this would be the place to unmount SPIFFS using SPIFFS.end()
      Serial.println("Start updating " + type);
    })
    .onEnd([]() {
      Serial.println("\nEnd");
    })
    .onProgress([](unsigned int progress, unsigned int total) {
      Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
    })
    .onError([](ota_error_t error) {
      Serial.printf("Error[%u]: ", error);
      if (error == OTA_AUTH_ERROR) Serial.println("Auth Failed");
      else if (error == OTA_BEGIN_ERROR) Serial.println("Begin Failed");
      else if (error == OTA_CONNECT_ERROR) Serial.println("Connect Failed");
      else if (error == OTA_RECEIVE_ERROR) Serial.println("Receive Failed");
      else if (error == OTA_END_ERROR) Serial.println("End Failed");
    });

  ArduinoOTA.begin();

  stp("Ready");
  stp("IP address: x x x x ");
  //stp(WiFi.localIP());
*/ 

  // Setup a function to be called every second
  timer.setInterval( 1000L, myTimerEvent );
  
  esp_task_wdt_init(WDT_TIMEOUT, true);		//enable panic so ESP32 restarts
  esp_task_wdt_add(NULL);					//add current thread to WDT watch
  
} // emd setup()

void loop() 
{
  esp_task_wdt_reset();
  
  //ArduinoOTA.handle();
  
  timer.run( ); // Initiates BlynkTimer   
  
  //Blynk.run( );
  
    if( Blynk.connected() ) 
	{  // If connected run as normal
	    Blynk.run();
	} 
	else 
			if( ReCnctFlag == 0 ) 
			{  // If NOT connected and not already trying to reconnect, set timer to try to reconnect in 30 seconds
				ReCnctFlag = 1;  // Set reconnection Flag
				Serial.println( "Starting reconnection timer in 30 seconds..." );
					timer.setTimeout(30000L, []() 
					{  // Lambda Reconnection Timer Function
						ReCnctFlag = 0;  // Reset reconnection Flag
						ReCnctCount++;  // Increment reconnection Counter
						Serial.print( "Attempting reconnection #" );
						Serial.println( ReCnctCount );
						Blynk.connect();  // Try to reconnect to the server
					});  // END Timer Function
			}

   
   if(millis( )-millis_int1 >= INTERVAL_GET_DATA) 
   {
      //   c DS18B20
      temp = get_data_ds18b20();
      //     
      
      //   
      millis_int1=millis();
 
   } // end    if(millis()-millis_int1 >= INTERVAL_GET_DATA) 
   
}  // end loop()


float get_data_ds18b20(void)   
{
  byte i;
  byte present = 0;
  byte type_s;
  byte data[12];
  byte addr[8];
  float fTemp;
  
  if ( !ds.search(addr)) 
  {
    //stp("\nNo more addresses.\n ");
    //Serial.println();
    ds.reset_search();
    delay(250);
    return 999;
  }
  
  //stp("\nROM =");
  
  for( i = 0; i < 8; i++) 
  {
    //Serial.write(' ');
    sprintf( tmps, " %x", addr[i] );
    //stp ( tmps );
    //Serial.print(addr[i], HEX); 
  }

  
  if (OneWire::crc8(addr, 7) != addr[7]) 
  {
      stp("CRC is not valid!\n");
      return 999;
  }
  //stp( "\n" );
 
  // the first ROM byte indicates which chip
  switch (addr[0]) 
  {
    case 0x10:
      //stp( "Chip = DS18S20\n" );  // or old DS1820
      type_s = 1;
      break;
    case 0x28:
      //stp("Chip = DS18B20\n");
      type_s = 0;
      break;
    case 0x22:
      //stp(" = DS1822\n");
      type_s = 0;
      break;
    default:
      stp("Device is not a DS18x20 family device./n");
      return 999;
  } // end switch (addr[0]) 

  ds.reset();
  ds.select( addr );
  //    
  ds.write( 0x44, 1 );          
  delay( 750 );     //  750 
  present = ds.reset();
  ds.select( addr );    
  ds.write( 0xBE );       
  //   
  for ( i = 0; i < 9; i++) 
  {           
    data[i] = ds.read();
    //Serial.print(data[i], HEX);
    sprintf( tmps, "%x ", data[i] );
    //stp( tmps );
    
  }
  //      
  int16_t raw = (data[1] << 8) | data[0];
  if (type_s) 
  {
    raw = raw << 3; 
    if (data[7] == 0x10) 
    {
      raw = (raw & 0xFFF0) + 12 - data[6];
    }
  } 
  else {
          byte cfg = (data[4] & 0x60);
          if (cfg == 0x00) raw = raw & ~7;  
          else if (cfg == 0x20) raw = raw & ~3; 
          else if (cfg == 0x40) raw = raw & ~1; 
       }
  fTemp = (float)raw / 16.0;

  return fTemp;

}  // end get_data_ds18b20(void) 

void stp( char *s )
{	//          ,   ,     
    Serial.print( s );
    terminal.print( s );
    terminal.flush();

} // void void stprint( char *s )


